<? /*************************************************************************************************
Copyright (c) 2003, 2004 Nathan 'Random' Rini
This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*************************************************************************************************/
 /*
  Region Class
 */

 class db_regions {
  var $regions; //region array - holds reference to regions

  //save all changes to db
  function update_db(){
   if(!empty($this->regions))
    foreach($this->regions as $region)
     if(!empty($region->data_mod) && $region->id > 0)
      new db_cmd("UPDATE", "regions", $region->data_mod, "id='".$region->id."'", 1);
  }

  //retrieve a region
  function &region($id = 0, $create = 0){
   if(!empty($this->regions[$id])) return $this->regions[$id];
   else {
    if(!($id > 0) && $create) $id = $this->create();
    return $this->regions[$id] = new db_region($id);
  }}

  //find region
  function &find_region($name){
   $query = new db_cmd("select", "regions", "id", "name LIKE '".convertsqlquotes($name)."'", 1);

   return $this->region($query->data[0]["id"]);
  }

  //create new region and then query it
  function create(){
   //grab next id
   $id = $GLOBALS["querys"]->nextid("regions", "id");

   //create entry
   new db_cmd("insert", "regions", array("id" => $id));

   return $id;
  }
 }

 class db_region {
  var $id;       //id
  var $data;     //data
  var $data_mod; //modified data

  function db_region($id = 0){
   $this->id = $id;

   if($id == '' || $id == 0) return;

   $query = new db_cmd("select", "regions", "*", "id='".$this->id."'", 1);
   $this->data = & $query->query->db_data[0]; //reference all user info

   $this->id = $this->get("id");
  }

  function delete(){
   new db_cmd("delete", "regions", "", "id = ".$this->id);

   $this->id = 0;
   $this->data = '';
   $this->data_mod = '';
  }

  function get($name){
   return $this->data[$name];
  }

  function set($name = '', $value = ''){
   if(is_array($name))
    foreach($name as $key => $data)
     $this->data_mod[$key] = $this->data[$key] = $data;
   else if($name != '')
    $this->data_mod[$name] = $this->data[$name] = $value;
  }
 }

 //write region option list
 function write_srvlocation_optlist($list){
  $query = new db_cmd("select", "regions", array("id", "name"), '', '', "name ASC");

  foreach($query->data as $region)
   $regionlist .= write_option($region["name"], findvalue($list, $region["id"]));

  return $regionlist;
 }

 //adds a location into a list by location name
 function addlistlocation($list, $location){global $regions;
  $region = &$regions->find_region($location);

  if($region->id > 0) return addvalue($list, $region->id);
  return $list;
 }

?>