<? /*************************************************************************************************
Copyright (c) 2003, 2004 Nathan 'Random' Rini
This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*************************************************************************************************/
 /*
  Team Invite Protocol
 */

 class db_team_invites {
  var $invites;      //invite array - holds reference to the invites
  var $user_invites; //user invite array - holds reference to the user invites arrays
  var $team_invites; //team invite array - holds reference to the user invites arrays

  //save all changes to db
  function update_db(){
   if(!empty($this->invites))
    foreach($this->invites as $invite)
     if(!empty($invite->data_mod) && $invite->id > 0)
      new db_cmd("UPDATE", "teaminvites", $invite->data_mod, "inviteid='".$invite->id."'", 1);
  }

  //returns if user is invited to a team
  function user_team_invite($user, $team){
   $uid = is_object($user) ? $user->id : $user;
   $tid = is_object($team) ? $team->id : $team;

   $query = new db_cmd("select", "teaminvites", "inviteid", "userid='".$uid."' AND team='".$tid."'");

   return $query->query->db_data[0]["inviteid"] > 0;
  }

  //retrieve array of user invites
  function user_invite($user){
   $id = is_object($user) ? $user->id : $user;

   if(isset($this->user_invites[$id])) return $this->user_invites[$id];

   $query = new db_cmd("select", "teaminvites", "inviteid", "userid='".$id."'");

   foreach($query->query->db_data as $invite)
    $invites[] = $invite["inviteid"];

   return $this->user_invites[$id] = $invites;
  }

  //retrieve array of user invites for a team
  function team_invite($team){
   $id = is_object($team) ? $team->id : $team;

   if(isset($this->team_invites[$id])) return $this->team_invites[$id];

   $query = new db_cmd("select", "teaminvites", "inviteid", "team='".$id."'");

   foreach($query->query->db_data as $invite)
    $invites[] = $invite["inviteid"];

   return $this->user_invites[$id] = $invites;
  }

  //retrieve a invite
  function &invite($id = 0, $create = 0){
   if(!empty($this->invites[$id])) return $this->invites[$id];
   else {
    if($create) $id = $this->create();
    return $this->invites[$id] = new db_team_invite($id);
  }}

  //create new invite and then query it from the db
  function create(){
   //grab next id
   $id = $GLOBALS["querys"]->nextid("teaminvites", "inviteid");

   //create entry
   new db_cmd("insert", "teaminvites", array("inviteid" => $id));

   return $id;
  }

  //clear command for all team invites to player
  function delete($team,$user){
   new db_cmd("delete", "teaminvites", "", "userid = ".$user." AND team = ".$team);
  }
 }

 class db_team_invite {
  var $id;            //invite id
  var $data;          //invite data
  var $data_mod;      //modified invite data

  function db_team_invite($id = 0){
   $this->id = $id;

   if($id == '' || $id == 0) return;

   $query = new db_cmd("select", "teaminvites", "*", "inviteid='".$this->id."'", 1);
   $this->data = & $query->query->db_data[0]; //reference all invite info
  }

  function delete(){
   new db_cmd("delete", "teaminvites", "", "inviteid = ".$this->id);

   $this->id = 0;
   $this->data = '';
   $this->data_mod = '';
  }

  function get($name){
   return $this->data[$name];
  }

  function set($name = '', $value = ''){
   if(is_array($name))
    foreach($name as $key => $data)
     $this->data_mod[$key] = $this->data[$key] = $data;
   else if($name != '')
    $this->data_mod[$name] = $this->data[$name] = $value;
  }
 }

?>